//This program converts from 2-bit (4 color) RAW to ti-89 C code for TIGCC grayscale.

#include <fstream.h>
#include <iostream.h>
#include <apstring.h>
#include <apstring.cpp>
#include <apvector.h>
#include <stdlib.h>
#include <conio.h>

bool CheckTI89Sum(const char*);

int main() {

	cout << "\n\nCH's RAW289Z - ch_2005@programmer.net\n";
	cout << "4 color RAW (first four of 8-bit RAW) to TI-89/92+ (89Z, 9XZ)\n\n";
	
	apstring raw_name;
	apstring z_name;
		
	cout << "Input name of RAW input (with extension) ('done' to exit): ";
	cin >> raw_name;

	while (raw_name != "done") {
		cout << "Input name of 89z/9xz output (with extension): ";
		cin >> z_name;
		cout << "160x100 screen? (decreases file size if only gonna be used on TI-89, still 240x128 input raw) (y/n)" << endl;
		if (getch() == 'y' || getch() == 'Y') {
			
			cin.ignore(1,'\n');

			ifstream raw;
			raw.open(raw_name.c_str(),ios::in);
		
				apvector<bool> light(30720,0);
				apvector<bool> dark(30720,0);
				char swt;
			
				for(int i = 0; i < 30720; i++) {
			
					raw >> swt;
					switch (swt) {
					case 1:
						light[i] = true;
						break;
					case 2:
						dark[i] = true;
						break;
					case 3:
						light[i] = dark[i] = true;
						break;
					}
			
				}
	
			raw.close();
		
			ofstream z;
			z.open(z_name.c_str(),ios::binary);
				
				ifstream before;
				before.open("before89.bin", ios::binary);					
						for(i = 0; i < 222; i++) {						
							z.put(char(before.get()));
						}
				before.close();
				
				int temp_char = 0;
	
				for(int l = 0; l < 100; l++) {
					for(int j = 0; j < 20; j++) {
						temp_char = 0;
						for(int k = 0; k < 8; k++) {
							temp_char *= 2;
							temp_char += light[l * 240 + j * 8 + k];
						}
						z.put(char(temp_char));
					}
				}
				for(l = 0; l < 100; l++) {
					for(int j = 0; j < 20; j++) {
						temp_char = 0;
						for(int k = 0; k < 8; k++) {
							temp_char *= 2;
							temp_char += dark[l * 240 + j * 8 + k];
						}
						z.put(char(temp_char));
					}
				}
				
				ifstream after;
				after.open("after89.bin", ios::binary);					
						for(i = 0; i < 1279; i++) {						
							z.put(char(after.get()));
						}
				after.close();
	
				apstring folder,var;			
				cout << "Enter folder name (8 char): ";
				cin >> folder;
				while(folder.length() > 8) cin >> folder;
				cout << "Enter variable name (8 char): ";
				cin >> var;
				while(folder.length() > 8) cin >> var;
	
				z.seekp(10);
				for(i = 0; i < folder.length(); i++) z.put(char(folder[i]));
				for(i = 0; i < 8 - folder.length(); i++) z.put(char(0));
	
				z.seekp(64);
				for(i = 0; i < var.length(); i++) z.put(char(var[i]));
				for(i = 0; i < 8 - var.length(); i++) z.put(char(0));
	
			z.close();
	
			CheckTI89Sum(z_name.c_str());
	
			cout << "Converted.\n\n";
			cout << "Input name of RAW input (with extension) ('done' to exit): ";
			cin >> raw_name;

		}
		else {
			cin.ignore(1,'\n');
			ifstream raw;
			raw.open(raw_name.c_str(),ios::in);
		
				apvector<bool> light(30720,0);
				apvector<bool> dark(30720,0);
				char swt;
			
				for(int i = 0; i < 30720; i++) {
			
					raw >> swt;
					switch (swt) {
					case 1:
						light[i] = true;
						break;
					case 2:
						dark[i] = true;
						break;
					case 3:
						light[i] = dark[i] = true;
						break;
					}
			
				}
	
			raw.close();
		
			ofstream z;
			z.open(z_name.c_str(),ios::binary);
				
				ifstream before;
				before.open("before.bin", ios::binary);					
						for(i = 0; i < 222; i++) {						
							z.put(char(before.get()));
						}
				before.close();
				
				int temp_char = 0;
	
				for(int j = 0; j < 3840; j++) {
					temp_char = 0;
					for(int k = 0; k < 8; k++) {
						temp_char *= 2;
						temp_char += light[j * 8 + k];
					}
					z.put(char(temp_char));
				}
				for(j = 0; j < 3840; j++) {
					temp_char = 0;
					for(int k = 0; k < 8; k++) {
						temp_char *= 2;
						temp_char += dark[j * 8 + k];
					}
					z.put(char(temp_char));
				}
				
				ifstream after;
				after.open("after.bin", ios::binary);					
						for(i = 0; i < 1271; i++) {						
							z.put(char(after.get()));
						}
				after.close();
	
				apstring folder,var;			
				cout << "Enter folder name (8 char): ";
				cin >> folder;
				while(folder.length() > 8) cin >> folder;
				cout << "Enter variable name (8 char): ";
				cin >> var;
				while(folder.length() > 8) cin >> var;
	
				z.seekp(10);
				for(i = 0; i < folder.length(); i++) z.put(char(folder[i]));
				for(i = 0; i < 8 - folder.length(); i++) z.put(char(0));
	
				z.seekp(64);
				for(i = 0; i < var.length(); i++) z.put(char(var[i]));
				for(i = 0; i < 8 - var.length(); i++) z.put(char(0));
	
			z.close();
	
			CheckTI89Sum(z_name.c_str());
	
			cout << "Converted.\n\n";
			cout << "Input name of RAW input (with extension) ('done' to exit): ";
			cin >> raw_name;

		}

	}

	cout << "Thank You.\n\n";

	return 0;
}

#include <bool.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "strhead.h"

bool CheckTI89Sum(const char* path)
{
	FILE*         fp;
    long          len;
    unsigned char ftype;
    unsigned char chk1;
    unsigned char chk2;
    unsigned int  ochecksum;
    unsigned int  checksum;
    unsigned char h[4];
    long          loop;
       
	int argc = 2;


    if (!(fp = fopen(path,"rb+"))) return false;
    
    h[0] = fgetc(fp);
    h[1] = fgetc(fp);
    h[2] = fgetc(fp);
    h[3] = fgetc(fp);
    
    if (h[0] != '*' || h[1] != '*' || h[2] != 'T' || h[3] != 'I')
	{
        fclose(fp);
        return false;
    }
    
    if (fseek(fp,-3,SEEK_END))
	{
        fclose(fp);
        return false;
    }
    
    ftype = fgetc(fp);
    chk1  = fgetc(fp);
    chk2  = fgetc(fp);
    len   = ftell(fp);
    
    ochecksum = (chk2 << 8) + chk1;
    
    //fprintf(stderr,"length=%ld type=%02x checksum=%u (0x%02x%02x)\n",len,ftype,ochecksum,chk1,chk2);

    if (ftype != 0x2d && ftype != 0xf8 && ftype != 0xf3)
	{
        fclose(fp);
        return false;
    }
    
    fseek(fp,sizeof(StrHeader)-2,SEEK_SET);
	
    checksum = 0;

    for (loop=sizeof(StrHeader)-2;loop<len-2;loop++) {
        checksum += fgetc(fp);
    }

    chk1     = checksum%256;
    chk2     = checksum/256;
    checksum = (chk2 << 8) + chk1;

    if (checksum == ochecksum) {
        //fprintf(stderr,"checksum already ok. will not patch.\n");
    }
    else {
        //fprintf(stderr,"checksum wrong. correcting it to %u (0x%02x%02x)\n",checksum,chk1,chk2);
        fseek(fp,-2,SEEK_END);
        fputc(chk1,fp);
        fputc(chk2,fp);        
    }
        
    fclose(fp);

    return true;
}